

<!DOCTYPE html>
<html class="writer-html5" lang="ru" >
<head>
  <meta charset="utf-8" />
  
<!-- Yandex.Metrika counter -->
<script async="" src="https://mc.yandex.ru/metrika/tag.js"></script>
<script type="text/javascript">
	(function(m,e,t,r,i,k,a){m[i]=m[i]||function(){(m[i].a=m[i].a||[]).push(arguments)};
	m[i].l=1*new Date();k=e.createElement(t),a=e.getElementsByTagName(t)[0],k.async=1,k.src=r,a.parentNode.insertBefore(k,a)})
	(window, document, "script", "https://mc.yandex.ru/metrika/tag.js", "ym");
 
	ym(88079149, "init", {
		 clickmap:true,
		 trackLinks:true,
		 accurateTrackBounce:true,
		 webvisor:true
	});
 </script>
 <noscript><div><img src="https://mc.yandex.ru/watch/88079149" style="position:absolute; left:-9999px;" alt="" /></div></noscript>
 <!-- /Yandex.Metrika counter -->



  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>pyOpenRPA.Robot.Keyboard &mdash; документация pyOpenRPA v1.3.1 v1.3.1</title>
  

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />

  
  
    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script src="../../../_static/translations.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    
    <link rel="index" title="Алфавитный указатель" href="../../../genindex.html" />
    <link rel="search" title="Поиск" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> pyOpenRPA v1.3.1
          

          
          </a>

          
            
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Поиск в документации" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">ОБЩЕЕ</span></p>
<ul>
<li class="toctree-l1"><a class="reference external" href="https://pyopenrpa.ru/wiki/guide/index">Выбрать версию</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../01_HowToInstall.html">1. Первый запуск (Windows &amp; Linux)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../03_Copyrights_Contacts.html">2. Лицензия &amp; Контакты</a></li>
</ul>
<p class="caption"><span class="caption-text">МОДУЛЬ РОБОТ</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/01_Robot.html">1. Описание</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/02_uidesktop.html">2. Функции UIDesktop</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/03_uiweb.html">3. Функции UIWeb</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/04_keyboard.html">4. Функции Keyboard</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/05_clipboard.html">5. Функции Clipboard</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/06_mouse.html">6. Функции Mouse</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/07_screen.html">7. Функции Screen</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/08_audio.html">8. Функции Audio</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Robot/09_HowToUse.html">9. Как использовать?</a></li>
</ul>
<p class="caption"><span class="caption-text">МОДУЛЬ СТУДИЯ</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../Studio/01_Studio.html">1. Описание</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Studio/02_HowToUse.html">2. Как использовать?</a></li>
</ul>
<p class="caption"><span class="caption-text">МОДУЛЬ ОРКЕСТРАТОР</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../Orchestrator/01_Orchestrator.html">1. Описание</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Orchestrator/02_Defs.html">2. Функции</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Orchestrator/03_gSettingsTemplate.html">3. Настройки GSettings (шаблон)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Orchestrator/04_HowToUse.html">4. Как использовать?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../Orchestrator/05_UAC.html">5. Права доступа пользователей UAC</a></li>
</ul>
<p class="caption"><span class="caption-text">МОДУЛЬ АГЕНТ</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../Agent/02_Defs.html">2. Функции Agent</a></li>
</ul>
<p class="caption"><span class="caption-text">ИНСТРУМЕНТЫ</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../Tools/02_Defs.html">2. Функции StopSafe</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">pyOpenRPA v1.3.1</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
        
          <li><a href="../../index.html">Код модуля</a> &raquo;</li>
        
      <li>pyOpenRPA.Robot.Keyboard</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Исходный код pyOpenRPA.Robot.Keyboard</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">pyOpenRPA.Tools</span> <span class="kn">import</span> <span class="n">CrossOS</span>
<span class="k">if</span> <span class="n">CrossOS</span><span class="o">.</span><span class="n">IS_WINDOWS_BOOL</span><span class="p">:</span> <span class="kn">from</span> <span class="nn">keyboard</span> <span class="kn">import</span> <span class="o">*</span>
<span class="k">elif</span> <span class="n">CrossOS</span><span class="o">.</span><span class="n">IS_LINUX_BOOL</span><span class="p">:</span> 
    <span class="kn">import</span> <span class="nn">pyautogui</span><span class="o">,</span> <span class="nn">sys</span><span class="o">,</span> <span class="nn">os</span>
    <span class="n">press</span> <span class="o">=</span> <span class="n">pyautogui</span><span class="o">.</span><span class="n">keyDown</span>
    <span class="n">release</span> <span class="o">=</span> <span class="n">pyautogui</span><span class="o">.</span><span class="n">keyUp</span>
    <span class="k">def</span> <span class="nf">send</span><span class="p">(</span><span class="n">hotkey</span><span class="p">,</span> <span class="n">do_press</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">do_release</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">do_press</span> <span class="ow">and</span> <span class="n">do_release</span><span class="p">:</span> <span class="n">pyautogui</span><span class="o">.</span><span class="n">press</span><span class="p">(</span><span class="n">hotkey</span><span class="p">);</span> <span class="k">return</span>
        <span class="k">if</span> <span class="n">do_press</span><span class="p">:</span> <span class="n">press</span><span class="p">(</span><span class="n">hotkey</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">do_release</span><span class="p">:</span> <span class="n">release</span><span class="p">(</span><span class="n">hotkey</span><span class="p">)</span>

<span class="n">WIN</span> <span class="o">=</span> <span class="n">CrossOS</span><span class="o">.</span><span class="n">IS_WINDOWS_BOOL</span>
<span class="n">LIN</span> <span class="o">=</span> <span class="n">CrossOS</span><span class="o">.</span><span class="n">IS_LINUX_BOOL</span>
<span class="kn">import</span> <span class="nn">time</span>

<span class="c1"># Настройки модуля Keyboard</span>
<span class="n">WAIT_AFTER_SEC_FLOAT</span> <span class="o">=</span> <span class="mf">0.4</span> <span class="c1"># Время, которое ожидать после выполнения любой операции модуля Keyboard. Настройка является единой для всех участов кода, использующих модуль Keyboard. Если для некоторой функции требуется изменить данное время ожидания, то в отношении этой функции можно применить соответсвующий аргумент.</span>

<span class="c1"># ШЕСТНАДЦАТИРИЧНЫЙ СКАН-КОД В РУССКОЙ РАСКЛАДКЕ (НЕЗАВИСИМО ОТ ВЫБРАННОГО ЯЗЫКА НА КЛАВИАТУРЕ) </span>
<span class="c1"># ОТОБРАЖЕНИЕ СКАН КОДОВ НА КЛАВИАТУРЕ https://snipp.ru/handbk/scan-codes</span>

<span class="n">KEY_RUS_LAYOUT</span> <span class="o">=</span> <span class="s2">&quot;ru&quot;</span> <span class="c1"># NEED FOR LINUX (FOR LAYOUT SWITCH)</span>
<span class="n">KEY_RUS_Ф</span> <span class="o">=</span> <span class="mh">0x1E</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;a&#39;</span> <span class="c1">#A</span>
<span class="n">KEY_RUS_И</span> <span class="o">=</span> <span class="mh">0x30</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;b&#39;</span> <span class="c1">#B</span>
<span class="n">KEY_RUS_С</span> <span class="o">=</span> <span class="mh">0x2E</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;c&#39;</span> <span class="c1">#C</span>
<span class="n">KEY_RUS_В</span> <span class="o">=</span> <span class="mh">0x20</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;d&#39;</span> <span class="c1">#D</span>
<span class="n">KEY_RUS_У</span> <span class="o">=</span> <span class="mh">0x12</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;e&#39;</span> <span class="c1">#E</span>
<span class="n">KEY_RUS_А</span> <span class="o">=</span> <span class="mh">0x21</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f&#39;</span> <span class="c1">#F</span>
<span class="n">KEY_RUS_П</span> <span class="o">=</span> <span class="mh">0x22</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;g&#39;</span> <span class="c1">#G</span>
<span class="n">KEY_RUS_Р</span> <span class="o">=</span> <span class="mh">0x23</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;h&#39;</span> <span class="c1">#H</span>
<span class="n">KEY_RUS_Ш</span> <span class="o">=</span> <span class="mh">0x17</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;i&#39;</span> <span class="c1">#I</span>
<span class="n">KEY_RUS_О</span> <span class="o">=</span> <span class="mh">0x24</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;j&#39;</span> <span class="c1">#J</span>
<span class="n">KEY_RUS_Л</span> <span class="o">=</span> <span class="mh">0x25</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;k&#39;</span> <span class="c1">#K</span>
<span class="n">KEY_RUS_Д</span> <span class="o">=</span> <span class="mh">0x26</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;l&#39;</span> <span class="c1">#L</span>
<span class="n">KEY_RUS_Ь</span> <span class="o">=</span> <span class="mh">0x32</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;m&#39;</span> <span class="c1">#M</span>
<span class="n">KEY_RUS_Т</span> <span class="o">=</span> <span class="mh">0x31</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;n&#39;</span> <span class="c1">#N</span>
<span class="n">KEY_RUS_Щ</span> <span class="o">=</span> <span class="mh">0x18</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;o&#39;</span> <span class="c1">#O</span>
<span class="n">KEY_RUS_З</span> <span class="o">=</span> <span class="mh">0x19</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;p&#39;</span> <span class="c1">#P</span>
<span class="n">KEY_RUS_Й</span> <span class="o">=</span> <span class="mh">0x10</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;q&#39;</span> <span class="c1">#Q</span>
<span class="n">KEY_RUS_К</span> <span class="o">=</span> <span class="mh">0x13</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;r&#39;</span> <span class="c1">#R</span>
<span class="n">KEY_RUS_Ы</span> <span class="o">=</span> <span class="mh">0x1F</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;s&#39;</span> <span class="c1">#S</span>
<span class="n">KEY_RUS_Е</span> <span class="o">=</span> <span class="mh">0x14</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;t&#39;</span> <span class="c1">#T</span>
<span class="n">KEY_RUS_Г</span> <span class="o">=</span> <span class="mh">0x16</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;u&#39;</span> <span class="c1">#U</span>
<span class="n">KEY_RUS_М</span> <span class="o">=</span> <span class="mh">0x2F</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;v&#39;</span> <span class="c1">#V</span>
<span class="n">KEY_RUS_Ц</span> <span class="o">=</span> <span class="mh">0x11</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;w&#39;</span> <span class="c1">#W</span>
<span class="n">KEY_RUS_Ч</span> <span class="o">=</span> <span class="mh">0x2D</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;x&#39;</span> <span class="c1">#X</span>
<span class="n">KEY_RUS_Н</span> <span class="o">=</span> <span class="mh">0x15</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;y&#39;</span> <span class="c1">#Y</span>
<span class="n">KEY_RUS_Я</span> <span class="o">=</span> <span class="mh">0x2C</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;z&#39;</span> <span class="c1">#Z</span>
<span class="n">KEY_RUS_Ё</span> <span class="o">=</span> <span class="mh">0x29</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;~&#39;</span> <span class="c1">#~</span>
<span class="n">KEY_RUS_Ж</span> <span class="o">=</span> <span class="mh">0x27</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;:&#39;</span> <span class="c1">#:</span>
<span class="n">KEY_RUS_Б</span> <span class="o">=</span> <span class="mh">0x33</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;&lt;&#39;</span> <span class="c1">#&lt;</span>
<span class="n">KEY_RUS_Ю</span> <span class="o">=</span> <span class="mh">0x34</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;&gt;&#39;</span> <span class="c1">#&gt;</span>
<span class="n">KEY_RUS_Х</span> <span class="o">=</span> <span class="mh">0x1A</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;[&#39;</span> <span class="c1">#[</span>
<span class="n">KEY_RUS_Ъ</span> <span class="o">=</span> <span class="mh">0x1B</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;]&#39;</span> <span class="c1">#]</span>
<span class="n">KEY_RUS_Э</span> <span class="o">=</span> <span class="mh">0x28</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s2">&quot;&#39;&quot;</span> <span class="c1">#&#39;</span>
 
<span class="n">KEY_ENG_LAYOUT</span> <span class="o">=</span> <span class="s2">&quot;us&quot;</span> <span class="c1"># NEED FOR LINUX (FOR LAYOUT SWITCH)</span>
<span class="n">KEY_ENG_A</span> <span class="o">=</span> <span class="mh">0x1E</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;a&#39;</span> <span class="c1">#A</span>
<span class="n">KEY_ENG_B</span> <span class="o">=</span> <span class="mh">0x30</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;b&#39;</span> <span class="c1">#B</span>
<span class="n">KEY_ENG_C</span> <span class="o">=</span> <span class="mh">0x2E</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;c&#39;</span> <span class="c1">#C</span>
<span class="n">KEY_ENG_D</span> <span class="o">=</span> <span class="mh">0x20</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;d&#39;</span> <span class="c1">#D</span>
<span class="n">KEY_ENG_E</span> <span class="o">=</span> <span class="mh">0x12</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;e&#39;</span> <span class="c1">#E</span>
<span class="n">KEY_ENG_F</span> <span class="o">=</span> <span class="mh">0x21</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f&#39;</span> <span class="c1">#F</span>
<span class="n">KEY_ENG_G</span> <span class="o">=</span> <span class="mh">0x22</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;g&#39;</span> <span class="c1">#G</span>
<span class="n">KEY_ENG_H</span> <span class="o">=</span> <span class="mh">0x23</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;h&#39;</span> <span class="c1">#H</span>
<span class="n">KEY_ENG_I</span> <span class="o">=</span> <span class="mh">0x17</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;i&#39;</span> <span class="c1">#I</span>
<span class="n">KEY_ENG_J</span> <span class="o">=</span> <span class="mh">0x24</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;j&#39;</span> <span class="c1">#J</span>
<span class="n">KEY_ENG_K</span> <span class="o">=</span> <span class="mh">0x25</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;k&#39;</span> <span class="c1">#K</span>
<span class="n">KEY_ENG_L</span> <span class="o">=</span> <span class="mh">0x26</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;l&#39;</span> <span class="c1">#L</span>
<span class="n">KEY_ENG_M</span> <span class="o">=</span> <span class="mh">0x32</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;m&#39;</span> <span class="c1">#M</span>
<span class="n">KEY_ENG_N</span> <span class="o">=</span> <span class="mh">0x31</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;n&#39;</span> <span class="c1">#N</span>
<span class="n">KEY_ENG_O</span> <span class="o">=</span> <span class="mh">0x18</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;o&#39;</span> <span class="c1">#O</span>
<span class="n">KEY_ENG_P</span> <span class="o">=</span> <span class="mh">0x19</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;p&#39;</span> <span class="c1">#P</span>
<span class="n">KEY_ENG_Q</span> <span class="o">=</span> <span class="mh">0x10</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;q&#39;</span> <span class="c1">#Q</span>
<span class="n">KEY_ENG_R</span> <span class="o">=</span> <span class="mh">0x13</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;r&#39;</span> <span class="c1">#R</span>
<span class="n">KEY_ENG_S</span> <span class="o">=</span> <span class="mh">0x1F</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;s&#39;</span> <span class="c1">#S</span>
<span class="n">KEY_ENG_T</span> <span class="o">=</span> <span class="mh">0x14</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;t&#39;</span> <span class="c1">#T</span>
<span class="n">KEY_ENG_U</span> <span class="o">=</span> <span class="mh">0x16</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;u&#39;</span> <span class="c1">#U</span>
<span class="n">KEY_ENG_V</span> <span class="o">=</span> <span class="mh">0x2F</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;v&#39;</span> <span class="c1">#V</span>
<span class="n">KEY_ENG_W</span> <span class="o">=</span> <span class="mh">0x11</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;w&#39;</span> <span class="c1">#W</span>
<span class="n">KEY_ENG_X</span> <span class="o">=</span> <span class="mh">0x2D</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;x&#39;</span> <span class="c1">#X</span>
<span class="n">KEY_ENG_Y</span> <span class="o">=</span> <span class="mh">0x15</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;y&#39;</span> <span class="c1">#Y</span>
<span class="n">KEY_ENG_Z</span> <span class="o">=</span> <span class="mh">0x2C</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;z&#39;</span> <span class="c1">#Z</span>

<span class="n">KEY_ENG_TILDE</span> <span class="o">=</span> <span class="mh">0x29</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;~&#39;</span> <span class="c1">#~</span>
<span class="n">KEY_ENG_COLON</span> <span class="o">=</span> <span class="mh">0x27</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;:&#39;</span> <span class="c1">#:</span>
<span class="n">KEY_ENG_PLUS</span> <span class="o">=</span> <span class="mh">0x0D</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;+&#39;</span> <span class="c1">#+</span>
<span class="n">KEY_ENG_MINUS</span> <span class="o">=</span> <span class="mh">0x0C</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;-&#39;</span> <span class="c1">#-</span>
<span class="n">KEY_ENG_LESS_THAN</span> <span class="o">=</span> <span class="mh">0x33</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;&lt;&#39;</span> <span class="c1">#&lt; ,</span>
<span class="n">KEY_ENG_GREATER_THAN</span> <span class="o">=</span> <span class="mh">0x34</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;&gt;&#39;</span> <span class="c1">#&gt; .</span>
<span class="n">KEY_ENG_SOLIDUS</span> <span class="o">=</span> <span class="mh">0x35</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;/&#39;</span> <span class="c1">#/ ?</span>
<span class="n">KEY_ENG_SQUARE_BRACKET_LEFT</span> <span class="o">=</span> <span class="mh">0x1A</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;[&#39;</span>  <span class="c1">#[</span>
<span class="n">KEY_ENG_SQUARE_BRACKET_RIGHT</span> <span class="o">=</span> <span class="mh">0x1B</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;]&#39;</span> <span class="c1">#]</span>
<span class="n">KEY_ENG_APOSTROPHE</span> <span class="o">=</span> <span class="mh">0x28</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s2">&quot;&#39;&quot;</span> <span class="c1">#&#39; &quot;</span>
<span class="n">KEY_ENG_VERTICAL_LINE</span> <span class="o">=</span> <span class="mh">0x2B</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;|&#39;</span> <span class="c1">#| \</span>

<span class="n">KEY_ENG_NUMPAD_0</span> <span class="o">=</span> <span class="mh">0x52</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num0&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_1</span> <span class="o">=</span> <span class="mh">0x4F</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num1&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_2</span> <span class="o">=</span> <span class="mh">0x50</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num2&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_3</span> <span class="o">=</span> <span class="mh">0x51</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num3&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_4</span> <span class="o">=</span> <span class="mh">0x4B</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num4&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_5</span> <span class="o">=</span> <span class="mh">0x4C</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num5&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_6</span> <span class="o">=</span> <span class="mh">0x4D</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num6&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_7</span> <span class="o">=</span> <span class="mh">0x47</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num7&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_8</span> <span class="o">=</span> <span class="mh">0x48</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num8&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_9</span> <span class="o">=</span> <span class="mh">0x49</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num9&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_ASTERISK</span> <span class="o">=</span> <span class="mh">0x37</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;*&#39;</span>  <span class="c1">#*</span>
<span class="n">KEY_ENG_NUMPAD_PLUS</span> <span class="o">=</span> <span class="mh">0x4E</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;+&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_MINUS</span> <span class="o">=</span> <span class="mh">0x4A</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;-&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_DELETE</span> <span class="o">=</span> <span class="mh">0x53</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;delete&#39;</span> 
<span class="n">KEY_ENG_NUMPAD_SOLIDUS</span> <span class="o">=</span> <span class="mh">0x35</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;/&#39;</span> <span class="c1">#/ </span>
<span class="n">KEY_ENG_NUMPAD_ENTER</span> <span class="o">=</span> <span class="mh">0x11c</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;enter&#39;</span> 

<span class="n">KEY_ENG_0</span> <span class="o">=</span> <span class="mh">0xB</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;0&#39;</span> 
<span class="n">KEY_ENG_1</span> <span class="o">=</span> <span class="mh">0x2</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;1&#39;</span> 
<span class="n">KEY_ENG_2</span> <span class="o">=</span> <span class="mh">0x3</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;2&#39;</span> 
<span class="n">KEY_ENG_3</span> <span class="o">=</span> <span class="mh">0x4</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;3&#39;</span> 
<span class="n">KEY_ENG_4</span> <span class="o">=</span> <span class="mh">0x5</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;4&#39;</span> 
<span class="n">KEY_ENG_5</span> <span class="o">=</span> <span class="mh">0x6</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;5&#39;</span> 
<span class="n">KEY_ENG_6</span> <span class="o">=</span> <span class="mh">0x7</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;6&#39;</span> 
<span class="n">KEY_ENG_7</span> <span class="o">=</span> <span class="mh">0x8</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;7&#39;</span> 
<span class="n">KEY_ENG_8</span> <span class="o">=</span> <span class="mh">0x9</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;8&#39;</span> 
<span class="n">KEY_ENG_9</span> <span class="o">=</span> <span class="mh">0xA</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;9&#39;</span> 

<span class="n">KEY_HOT_NUMPAD_0</span> <span class="o">=</span> <span class="mh">0x52</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num0&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_1</span> <span class="o">=</span> <span class="mh">0x4F</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num1&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_2</span> <span class="o">=</span> <span class="mh">0x50</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num2&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_3</span> <span class="o">=</span> <span class="mh">0x51</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num3&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_4</span> <span class="o">=</span> <span class="mh">0x4B</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num4&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_5</span> <span class="o">=</span> <span class="mh">0x4C</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num5&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_6</span> <span class="o">=</span> <span class="mh">0x4D</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num6&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_7</span> <span class="o">=</span> <span class="mh">0x47</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num7&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_8</span> <span class="o">=</span> <span class="mh">0x48</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num8&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_9</span> <span class="o">=</span> <span class="mh">0x49</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;num9&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_ASTERISK</span> <span class="o">=</span> <span class="mh">0x37</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;*&#39;</span>  <span class="c1">#*</span>
<span class="n">KEY_HOT_NUMPAD_PLUS</span> <span class="o">=</span> <span class="mh">0x4E</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;+&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_MINUS</span> <span class="o">=</span> <span class="mh">0x4A</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;-&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_DELETE</span> <span class="o">=</span> <span class="mh">0x53</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;delete&#39;</span> 
<span class="n">KEY_HOT_NUMPAD_SOLIDUS</span> <span class="o">=</span> <span class="mh">0x35</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;/&#39;</span> <span class="c1">#/ </span>
<span class="n">KEY_HOT_NUMPAD_ENTER</span> <span class="o">=</span> <span class="mh">0x11c</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;enter&#39;</span> 

<span class="n">KEY_HOT_F1</span> <span class="o">=</span> <span class="mh">0x3B</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f1&#39;</span> 
<span class="n">KEY_HOT_F2</span> <span class="o">=</span> <span class="mh">0x3C</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f2&#39;</span> 
<span class="n">KEY_HOT_F3</span> <span class="o">=</span> <span class="mh">0x3D</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f3&#39;</span> 
<span class="n">KEY_HOT_F4</span> <span class="o">=</span> <span class="mh">0x3E</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f4&#39;</span> 
<span class="n">KEY_HOT_F5</span> <span class="o">=</span> <span class="mh">0x3F</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f5&#39;</span> 
<span class="n">KEY_HOT_F6</span> <span class="o">=</span> <span class="mh">0x40</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f6&#39;</span> 
<span class="n">KEY_HOT_F7</span> <span class="o">=</span> <span class="mh">0x41</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f7&#39;</span> 
<span class="n">KEY_HOT_F8</span> <span class="o">=</span> <span class="mh">0x42</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f8&#39;</span> 
<span class="n">KEY_HOT_F9</span> <span class="o">=</span> <span class="mh">0x43</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f9&#39;</span> 
<span class="n">KEY_HOT_F10</span> <span class="o">=</span> <span class="mh">0x44</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f10&#39;</span> 
<span class="n">KEY_HOT_F11</span> <span class="o">=</span> <span class="mh">0x57</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f11&#39;</span> 
<span class="n">KEY_HOT_F12</span> <span class="o">=</span> <span class="mh">0x58</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f12&#39;</span> 
<span class="n">KEY_HOT_F13</span> <span class="o">=</span> <span class="mh">0x7C</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f13&#39;</span> 
<span class="n">KEY_HOT_F14</span> <span class="o">=</span> <span class="mh">0x7D</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f14&#39;</span> 
<span class="n">KEY_HOT_F15</span> <span class="o">=</span> <span class="mh">0x7E</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f15&#39;</span> 
<span class="n">KEY_HOT_F16</span> <span class="o">=</span> <span class="mh">0x7F</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f16&#39;</span> 
<span class="n">KEY_HOT_F17</span> <span class="o">=</span> <span class="mh">0x80</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f17&#39;</span> 
<span class="n">KEY_HOT_F18</span> <span class="o">=</span> <span class="mh">0x81</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f18&#39;</span> 
<span class="n">KEY_HOT_F19</span> <span class="o">=</span> <span class="mh">0x82</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f19&#39;</span>  
<span class="n">KEY_HOT_F20</span> <span class="o">=</span> <span class="mh">0x83</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f20&#39;</span> 
<span class="n">KEY_HOT_F21</span> <span class="o">=</span> <span class="mh">0x84</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f21&#39;</span> 
<span class="n">KEY_HOT_F22</span> <span class="o">=</span> <span class="mh">0x85</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f22&#39;</span> 
<span class="n">KEY_HOT_F23</span> <span class="o">=</span> <span class="mh">0x86</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f23&#39;</span> 
<span class="n">KEY_HOT_F24</span> <span class="o">=</span> <span class="mh">0x87</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;f24&#39;</span> 

<span class="n">KEY_HOT_TILDE</span> <span class="o">=</span> <span class="mh">0x29</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;~&#39;</span> <span class="c1">#~</span>
<span class="n">KEY_HOT_COLON</span> <span class="o">=</span> <span class="mh">0x27</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;:&#39;</span> <span class="c1">#:</span>
<span class="n">KEY_HOT_PLUS</span> <span class="o">=</span> <span class="mh">0x0D</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;+&#39;</span> <span class="c1">#+</span>
<span class="n">KEY_HOT_MINUS</span> <span class="o">=</span> <span class="mh">0x0C</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;-&#39;</span> <span class="c1">#-</span>
<span class="n">KEY_HOT_LESS_THAN</span> <span class="o">=</span> <span class="mh">0x33</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;&lt;&#39;</span> <span class="c1">#&lt; ,</span>
<span class="n">KEY_HOT_GREATER_THAN</span> <span class="o">=</span> <span class="mh">0x34</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;&gt;&#39;</span> <span class="c1">#&gt; .</span>
<span class="n">KEY_HOT_SOLIDUS</span> <span class="o">=</span> <span class="mh">0x35</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;/&#39;</span> <span class="c1">#/ ?</span>
<span class="n">KEY_HOT_SQUARE_BRACKET_LEFT</span> <span class="o">=</span> <span class="mh">0x1A</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;[&#39;</span>  <span class="c1">#[</span>
<span class="n">KEY_HOT_SQUARE_BRACKET_RIGHT</span> <span class="o">=</span> <span class="mh">0x1B</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;]&#39;</span> <span class="c1">#]</span>
<span class="n">KEY_HOT_APOSTROPHE</span> <span class="o">=</span> <span class="mh">0x28</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s2">&quot;&#39;&quot;</span> <span class="c1">#&#39; &quot;</span>
<span class="n">KEY_HOT_VERTICAL_LINE</span> <span class="o">=</span> <span class="mh">0x2B</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;|&#39;</span> <span class="c1">#| \</span>

<span class="n">KEY_HOT_ESC</span> <span class="o">=</span> <span class="mh">0x1</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;esc&#39;</span> 
<span class="n">KEY_HOT_BACKSPACE</span> <span class="o">=</span> <span class="mh">0x0E</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;backspace&#39;</span> 
<span class="n">KEY_HOT_TAB</span> <span class="o">=</span> <span class="mh">0x0F</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;tab&#39;</span> 
<span class="n">KEY_HOT_ENTER</span> <span class="o">=</span> <span class="mh">0x1C</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;enter&#39;</span> 
<span class="n">KEY_HOT_CONTEXT_MENU</span> <span class="o">=</span> <span class="mh">0x15D</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;apps&#39;</span> 
<span class="n">KEY_HOT_SHIFT_LEFT</span> <span class="o">=</span> <span class="mh">0x2A</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;shiftleft&#39;</span>
<span class="n">KEY_HOT_SHIFT_RIGHT</span> <span class="o">=</span> <span class="mh">0x36</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;shiftright&#39;</span>
<span class="n">KEY_HOT_CTRL_LEFT</span> <span class="o">=</span> <span class="mh">0x1D</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;ctrlleft&#39;</span>
<span class="n">KEY_HOT_CTRL_RIGHT</span> <span class="o">=</span> <span class="mh">0x11D</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;ctrlright&#39;</span>
<span class="n">KEY_HOT_ALT_LEFT</span> <span class="o">=</span> <span class="mh">0x38</span>  <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;altleft&#39;</span>
<span class="n">KEY_HOT_ALT_RIGHT</span> <span class="o">=</span> <span class="mh">0x138</span>  <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;altright&#39;</span>
<span class="n">KEY_HOT_WIN_LEFT</span> <span class="o">=</span> <span class="mi">57435</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;winleft&#39;</span> <span class="c1">#OLD AND DONT WORK 0x5B</span>
<span class="n">KEY_HOT_WIN_RIGHT</span> <span class="o">=</span> <span class="mi">57436</span>  <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;winright&#39;</span> <span class="c1">#OLD AND DONT WORK 0x5C</span>
<span class="n">KEY_HOT_CAPS_LOCK</span> <span class="o">=</span> <span class="mh">0x3A</span>  <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;capslock&#39;</span>
<span class="n">KEY_HOT_NUM_LOCK</span> <span class="o">=</span> <span class="mh">0x45</span>  <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;numlock&#39;</span>
<span class="n">KEY_HOT_SCROLL_LOCK</span> <span class="o">=</span> <span class="mh">0x46</span>  <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;scrolllock&#39;</span>
<span class="n">KEY_HOT_END</span> <span class="o">=</span> <span class="mh">0x4F</span>  <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;end&#39;</span>
<span class="n">KEY_HOT_HOME</span> <span class="o">=</span> <span class="mh">0x47</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;home&#39;</span>
<span class="n">KEY_HOT_SPACE</span> <span class="o">=</span> <span class="mh">0x39</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;space&#39;</span>
<span class="n">KEY_HOT_PAGE_UP</span> <span class="o">=</span> <span class="mh">0x49</span>  <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;pageup&#39;</span>
<span class="n">KEY_HOT_PAGE_DOWN</span> <span class="o">=</span> <span class="mh">0x51</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;pagedown&#39;</span>
<span class="n">KEY_HOT_CLEAR</span> <span class="o">=</span> <span class="mh">0x4C</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;clear&#39;</span>
<span class="n">KEY_HOT_LEFT</span> <span class="o">=</span> <span class="mh">0x4B</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;left&#39;</span>
<span class="n">KEY_HOT_UP</span> <span class="o">=</span> <span class="mh">0x48</span>  <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;up&#39;</span>
<span class="n">KEY_HOT_RIGHT</span> <span class="o">=</span> <span class="mh">0x4D</span>  <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;right&#39;</span>
<span class="n">KEY_HOT_DOWN</span> <span class="o">=</span> <span class="mh">0x50</span>  <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;down&#39;</span>
<span class="n">KEY_HOT_PRINT_SCREEN</span> <span class="o">=</span> <span class="mh">0x137</span>  <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;printscreen&#39;</span>
<span class="n">KEY_HOT_INSERT</span> <span class="o">=</span> <span class="mh">0x52</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;insert&#39;</span>
<span class="n">KEY_HOT_DELETE</span> <span class="o">=</span> <span class="mh">0x53</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;delete&#39;</span>

<span class="n">KEY_HOT_0</span> <span class="o">=</span> <span class="mh">0xB</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;0&#39;</span> 
<span class="n">KEY_HOT_1</span> <span class="o">=</span> <span class="mh">0x2</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;1&#39;</span> 
<span class="n">KEY_HOT_2</span> <span class="o">=</span> <span class="mh">0x3</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;2&#39;</span> 
<span class="n">KEY_HOT_3</span> <span class="o">=</span> <span class="mh">0x4</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;3&#39;</span> 
<span class="n">KEY_HOT_4</span> <span class="o">=</span> <span class="mh">0x5</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;4&#39;</span> 
<span class="n">KEY_HOT_5</span> <span class="o">=</span> <span class="mh">0x6</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;5&#39;</span> 
<span class="n">KEY_HOT_6</span> <span class="o">=</span> <span class="mh">0x7</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;6&#39;</span> 
<span class="n">KEY_HOT_7</span> <span class="o">=</span> <span class="mh">0x8</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;7&#39;</span> 
<span class="n">KEY_HOT_8</span> <span class="o">=</span> <span class="mh">0x9</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;8&#39;</span> 
<span class="n">KEY_HOT_9</span> <span class="o">=</span> <span class="mh">0xA</span> <span class="k">if</span> <span class="n">WIN</span> <span class="k">else</span> <span class="s1">&#39;9&#39;</span> 

<span class="n">MAP_RUS_ENG</span> <span class="o">=</span> <span class="p">{</span> <span class="c1"># FOR LINUX PURPOSE</span>
<span class="s2">&quot;Ё&quot;</span><span class="p">:</span><span class="s2">&quot;`&quot;</span><span class="p">,</span>
<span class="s2">&quot;Й&quot;</span><span class="p">:</span><span class="s2">&quot;q&quot;</span><span class="p">,</span>
<span class="s2">&quot;Ц&quot;</span><span class="p">:</span><span class="s2">&quot;w&quot;</span><span class="p">,</span>
<span class="s2">&quot;У&quot;</span><span class="p">:</span><span class="s2">&quot;e&quot;</span><span class="p">,</span>
<span class="s2">&quot;К&quot;</span><span class="p">:</span><span class="s2">&quot;r&quot;</span><span class="p">,</span>
<span class="s2">&quot;Е&quot;</span><span class="p">:</span><span class="s2">&quot;t&quot;</span><span class="p">,</span>
<span class="s2">&quot;Н&quot;</span><span class="p">:</span><span class="s2">&quot;y&quot;</span><span class="p">,</span>
<span class="s2">&quot;Г&quot;</span><span class="p">:</span><span class="s2">&quot;u&quot;</span><span class="p">,</span>
<span class="s2">&quot;Ш&quot;</span><span class="p">:</span><span class="s2">&quot;i&quot;</span><span class="p">,</span>
<span class="s2">&quot;Щ&quot;</span><span class="p">:</span><span class="s2">&quot;o&quot;</span><span class="p">,</span>
<span class="s2">&quot;З&quot;</span><span class="p">:</span><span class="s2">&quot;p&quot;</span><span class="p">,</span>
<span class="s2">&quot;Х&quot;</span><span class="p">:</span><span class="s2">&quot;[&quot;</span><span class="p">,</span>
<span class="s2">&quot;Ъ&quot;</span><span class="p">:</span><span class="s2">&quot;]&quot;</span><span class="p">,</span>
<span class="s2">&quot;Ф&quot;</span><span class="p">:</span><span class="s2">&quot;a&quot;</span><span class="p">,</span>
<span class="s2">&quot;Ы&quot;</span><span class="p">:</span><span class="s2">&quot;s&quot;</span><span class="p">,</span>
<span class="s2">&quot;В&quot;</span><span class="p">:</span><span class="s2">&quot;d&quot;</span><span class="p">,</span>
<span class="s2">&quot;А&quot;</span><span class="p">:</span><span class="s2">&quot;f&quot;</span><span class="p">,</span>
<span class="s2">&quot;П&quot;</span><span class="p">:</span><span class="s2">&quot;g&quot;</span><span class="p">,</span>
<span class="s2">&quot;Р&quot;</span><span class="p">:</span><span class="s2">&quot;h&quot;</span><span class="p">,</span>
<span class="s2">&quot;О&quot;</span><span class="p">:</span><span class="s2">&quot;j&quot;</span><span class="p">,</span>
<span class="s2">&quot;Л&quot;</span><span class="p">:</span><span class="s2">&quot;k&quot;</span><span class="p">,</span>
<span class="s2">&quot;Д&quot;</span><span class="p">:</span><span class="s2">&quot;l&quot;</span><span class="p">,</span>
<span class="s2">&quot;Ж&quot;</span><span class="p">:</span><span class="s2">&quot;;&quot;</span><span class="p">,</span>
<span class="s2">&quot;Э&quot;</span><span class="p">:</span><span class="s2">&quot;&#39;&quot;</span><span class="p">,</span>
<span class="s2">&quot;Я&quot;</span><span class="p">:</span><span class="s2">&quot;z&quot;</span><span class="p">,</span>
<span class="s2">&quot;Ч&quot;</span><span class="p">:</span><span class="s2">&quot;x&quot;</span><span class="p">,</span>
<span class="s2">&quot;С&quot;</span><span class="p">:</span><span class="s2">&quot;c&quot;</span><span class="p">,</span>
<span class="s2">&quot;М&quot;</span><span class="p">:</span><span class="s2">&quot;v&quot;</span><span class="p">,</span>
<span class="s2">&quot;И&quot;</span><span class="p">:</span><span class="s2">&quot;b&quot;</span><span class="p">,</span>
<span class="s2">&quot;Т&quot;</span><span class="p">:</span><span class="s2">&quot;n&quot;</span><span class="p">,</span>
<span class="s2">&quot;Ь&quot;</span><span class="p">:</span><span class="s2">&quot;m&quot;</span><span class="p">,</span>
<span class="s2">&quot;Б&quot;</span><span class="p">:</span><span class="s2">&quot;,&quot;</span><span class="p">,</span>
<span class="s2">&quot;Ю&quot;</span><span class="p">:</span><span class="s2">&quot;.&quot;</span>
<span class="p">}</span>

<div class="viewcode-block" id="Write"><a class="viewcode-back" href="../../../Robot/04_keyboard.html#pyOpenRPA.Robot.Keyboard.Write">[документация]</a><span class="k">def</span> <span class="nf">Write</span><span class="p">(</span><span class="n">inTextStr</span><span class="p">:</span><span class="nb">str</span><span class="p">,</span> <span class="n">inDelayFloat</span><span class="p">:</span><span class="nb">float</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">inRestoreStateAfterBool</span><span class="p">:</span><span class="nb">bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">inExactBool</span><span class="p">:</span><span class="nb">bool</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">inWaitAfterSecFloat</span><span class="p">:</span><span class="nb">float</span><span class="o">=</span><span class="n">WAIT_AFTER_SEC_FLOAT</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;L+,W+: Печатает текст, который был передан в переменной inTextStr (поддерживает передачу в одной строке символов разного языка). Не зависит от текущей раскладки клавиатуры! Посылает искусственные клавишные события в ОС, моделируя печать данного текста. Знаки, не доступные на клавиатуре, напечатаны как явный unicode знаки, использующие определенную для ОС функциональность, такие как alt+codepoint.</span>
<span class="sd">    Чтобы гарантировать текстовую целостность, все в настоящее время нажатые ключи выпущены прежде текст напечатан, и модификаторы восстановлены впоследствии.</span>

<span class="sd">    ВНИМАНИЕ! ПЕЧАТАЕТ ЛЮБУЮ СТРОКУ, ДАЖЕ В СОЧЕТАНИИ НЕСКОЛЬКИХ ЯЗЫКОВ ОДНОВРЕМЕННО. ДЛЯ РАБОТЫ С ГОРЯЧИМИ КЛАВИШАМИ ИСПОЛЬЗУЙ ФУНКЦИЮ Send, Up, Down, HotkeyCombination</span>

<span class="sd">    ВНИМАНИЕ! В LINUX НЕ ДЕЙСТВУЮТ СЛЕДУЮЩИЕ ПАРАМЕТРЫ: inRestoreStateAfterBool, inExactBool</span>

<span class="sd">    .. code-block:: python</span>

<span class="sd">        # Keyboard: Взаимодействие с клавиатурой</span>
<span class="sd">        from pyOpenRPA.Robot import Keyboard</span>
<span class="sd">        Keyboard.Write(&quot;Привет мой милый мир! Hello my dear world!&quot;)</span>

<span class="sd">    :param inTextStr: Текст, отправляемый на печать. Не зависит от текущей раскладки клавиатуры! </span>
<span class="sd">    :type inTextStr: str</span>
<span class="sd">    :param inDelayFloat: Число секунд, которое ожидать между нажатиями. По умолчанию 0</span>
<span class="sd">    :type inDelayFloat: float, опциональный</span>
<span class="sd">    :param inRestoreStateAfterBool: Может использоваться, чтобы восстановить регистр нажатых ключей после того, как текст напечатан, т.е. нажимает ключи, которые были выпущены в начало.</span>
<span class="sd">    :type inRestoreStateAfterBool: bool, опциональный</span>
<span class="sd">    :param inExactBool: Печатает все знаки как явный unicode. Необязательный параметр</span>
<span class="sd">    :type inExactBool: bool, опциональный</span>
<span class="sd">    :param inWaitAfterSecFloat: Количество секунд, которые ожидать после выполнения операции. По умолчанию установлено в настройках модуля Keyboard (базовое значение 0.4)</span>
<span class="sd">    :type inWaitAfterSecFloat: float, опциональный</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">CrossOS</span><span class="o">.</span><span class="n">IS_WINDOWS_BOOL</span><span class="p">:</span>
        <span class="n">write</span><span class="p">(</span><span class="n">text</span><span class="o">=</span><span class="n">inTextStr</span><span class="p">,</span> <span class="n">delay</span><span class="o">=</span><span class="n">inDelayFloat</span><span class="p">,</span> <span class="n">restore_state_after</span><span class="o">=</span><span class="n">inRestoreStateAfterBool</span><span class="p">,</span> <span class="n">exact</span><span class="o">=</span><span class="n">inExactBool</span><span class="p">)</span>
    <span class="k">elif</span> <span class="n">CrossOS</span><span class="o">.</span><span class="n">IS_LINUX_BOOL</span><span class="p">:</span>
        <span class="n">_WriteLinux</span><span class="p">(</span><span class="n">inTextStr</span><span class="o">=</span><span class="n">inTextStr</span><span class="p">,</span> <span class="n">inDelayFloat</span><span class="o">=</span><span class="n">inDelayFloat</span><span class="p">)</span>
    <span class="n">time</span><span class="o">.</span><span class="n">sleep</span><span class="p">(</span><span class="n">inWaitAfterSecFloat</span><span class="p">)</span></div>

<span class="k">def</span> <span class="nf">_WriteLinux</span><span class="p">(</span><span class="n">inTextStr</span><span class="p">,</span> <span class="n">inDelayFloat</span><span class="o">=</span><span class="mf">0.01</span><span class="p">):</span>
    <span class="n">lModuleKeyboard</span> <span class="o">=</span> <span class="n">sys</span><span class="o">.</span><span class="n">modules</span><span class="p">[</span><span class="vm">__name__</span><span class="p">]</span>
    <span class="n">lVarList</span> <span class="o">=</span> <span class="nb">dir</span><span class="p">(</span><span class="n">lModuleKeyboard</span><span class="p">)</span>
    <span class="n">lLayoutStr</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="k">for</span> <span class="n">lCharStr</span> <span class="ow">in</span> <span class="n">inTextStr</span><span class="p">:</span>
        <span class="c1"># Check rus (ru)</span>
        <span class="n">lVarNameStr</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;KEY_RUS_</span><span class="si">{</span><span class="n">lCharStr</span><span class="o">.</span><span class="n">upper</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span>
        <span class="n">lFoundBool</span> <span class="o">=</span> <span class="kc">False</span>
        <span class="n">lShiftBool</span> <span class="o">=</span> <span class="kc">False</span>
        <span class="k">if</span> <span class="n">lVarNameStr</span> <span class="ow">in</span> <span class="n">lVarList</span><span class="p">:</span> 
            <span class="n">lNewLayoutStr</span><span class="o">=</span><span class="nb">getattr</span><span class="p">(</span><span class="n">lModuleKeyboard</span><span class="p">,</span> <span class="s2">&quot;KEY_RUS_LAYOUT&quot;</span><span class="p">)</span>
            <span class="n">lCapBool</span> <span class="o">=</span> <span class="n">lCharStr</span><span class="o">.</span><span class="n">isupper</span><span class="p">()</span>
            <span class="n">lCharStr</span> <span class="o">=</span> <span class="n">MAP_RUS_ENG</span><span class="p">[</span><span class="n">lCharStr</span><span class="o">.</span><span class="n">upper</span><span class="p">()]</span>
            <span class="c1">#if lCapBool == True: lCharStr=lCharStr.upper()</span>
            <span class="k">if</span> <span class="n">lCapBool</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span> <span class="n">lShiftBool</span><span class="o">=</span><span class="kc">True</span>            
            <span class="n">lFoundBool</span><span class="o">=</span><span class="kc">True</span>
        <span class="c1"># Check eng (us)</span>
        <span class="n">lVarNameStr</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;KEY_ENG_</span><span class="si">{</span><span class="n">lCharStr</span><span class="o">.</span><span class="n">upper</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span>
        <span class="k">if</span> <span class="n">lVarNameStr</span> <span class="ow">in</span> <span class="n">lVarList</span> <span class="ow">and</span> <span class="n">lFoundBool</span> <span class="o">==</span> <span class="kc">False</span><span class="p">:</span> 
            <span class="n">lNewLayoutStr</span><span class="o">=</span><span class="nb">getattr</span><span class="p">(</span><span class="n">lModuleKeyboard</span><span class="p">,</span> <span class="s2">&quot;KEY_ENG_LAYOUT&quot;</span><span class="p">)</span>
            <span class="n">lFoundBool</span><span class="o">=</span><span class="kc">True</span>
        <span class="k">if</span> <span class="n">lFoundBool</span> <span class="o">==</span> <span class="kc">False</span><span class="p">:</span> <span class="n">lNewLayoutStr</span><span class="o">=</span><span class="nb">getattr</span><span class="p">(</span><span class="n">lModuleKeyboard</span><span class="p">,</span> <span class="s2">&quot;KEY_ENG_LAYOUT&quot;</span><span class="p">)</span>
        <span class="c1"># CHECK LAST LAYOUT</span>
        <span class="k">if</span> <span class="n">lNewLayoutStr</span> <span class="o">!=</span> <span class="n">lLayoutStr</span><span class="p">:</span> 
            <span class="c1">#print(f&quot;setxkbmap -layout {lNewLayoutStr}&quot;)</span>
            <span class="n">os</span><span class="o">.</span><span class="n">system</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;setxkbmap -layout </span><span class="si">{</span><span class="n">lNewLayoutStr</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
            <span class="n">lLayoutStr</span> <span class="o">=</span> <span class="n">lNewLayoutStr</span>
        <span class="k">if</span> <span class="n">lShiftBool</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span> <span class="n">pyautogui</span><span class="o">.</span><span class="n">keyDown</span><span class="p">(</span><span class="s1">&#39;shift&#39;</span><span class="p">)</span>  <span class="c1"># hold down the shift key</span>
        <span class="n">pyautogui</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">lCharStr</span><span class="p">,</span> <span class="n">interval</span> <span class="o">=</span> <span class="n">inDelayFloat</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">lShiftBool</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span> <span class="n">pyautogui</span><span class="o">.</span><span class="n">keyUp</span><span class="p">(</span><span class="s1">&#39;shift&#39;</span><span class="p">)</span>  <span class="c1"># hold down the shift key</span>
    
    <span class="c1"># Set 2 layout with alt+shift switch</span>
    <span class="n">os</span><span class="o">.</span><span class="n">system</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;setxkbmap -layout </span><span class="si">{</span><span class="nb">getattr</span><span class="p">(</span><span class="n">lModuleKeyboard</span><span class="p">,</span> <span class="s1">&#39;KEY_ENG_LAYOUT&#39;</span><span class="p">)</span><span class="si">}</span><span class="s2">,</span><span class="si">{</span><span class="nb">getattr</span><span class="p">(</span><span class="n">lModuleKeyboard</span><span class="p">,</span> <span class="s1">&#39;KEY_RUS_LAYOUT&#39;</span><span class="p">)</span><span class="si">}</span><span class="s2"> -option grp:alt_shift_toggle&quot;</span><span class="p">)</span>

<div class="viewcode-block" id="HotkeyCombination"><a class="viewcode-back" href="../../../Robot/04_keyboard.html#pyOpenRPA.Robot.Keyboard.HotkeyCombination">[документация]</a><span class="k">def</span> <span class="nf">HotkeyCombination</span><span class="p">(</span><span class="o">*</span><span class="n">inKeyList</span><span class="p">,</span> <span class="n">inDelaySecFloat</span> <span class="o">=</span> <span class="mf">0.3</span><span class="p">,</span><span class="n">inWaitAfterSecFloat</span><span class="p">:</span><span class="nb">float</span><span class="o">=</span><span class="n">WAIT_AFTER_SEC_FLOAT</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;L+,W+: Получает перечень клавиш для одновременного нажатия. Между нажатиями программа ожидания время inDelaySecFloat</span>
<span class="sd">    ВНИМАНИЕ! НЕ ЗАВИСИТ ОТ ТЕКУЩЕЙ РАСКЛАДКИ КЛАВИАТУРЫ</span>

<span class="sd">    .. code-block:: python</span>

<span class="sd">        # Keyboard: Взаимодействие с клавиатурой</span>
<span class="sd">        from pyOpenRPA.Robot import Keyboard</span>
<span class="sd">        Keyboard.HotkeyCombination(Keyboard.KEY_HOT_CTRL_LEFT,Keyboard.KEY_ENG_A) # Ctrl + a</span>
<span class="sd">        Keyboard.HotkeyCombination(Keyboard.KEY_HOT_CTRL_LEFT,Keyboard.KEY_ENG_C) # Ctrl + c</span>
<span class="sd">        Keyboard.HotkeyCombination(Keyboard.KEY_HOT_CTRL_LEFT,Keyboard.KEY_ENG_A)</span>
<span class="sd">        Keyboard.HotkeyCombination(Keyboard.KEY_HOT_ALT_LEFT,Keyboard.KEY_HOT_TAB, Keyboard.KEY_HOT_TAB)</span>
<span class="sd">    </span>
<span class="sd">    :param inKeyList: Список клавиш для одновременного нажатия. Перечень клавиш см. в разделе &quot;Коды клавиш&quot;. Пример: KEY_HOT_CTRL_LEFT,KEY_ENG_A</span>
<span class="sd">    :param inDelaySecFloat: Интервал между нажатиями. Необходим в связи с тем, что операционной системе требуется время на реакцию на нажатие клавиш, по умолчанию: 0.3</span>
<span class="sd">    :type inDelaySecFloat: float, опциональный</span>
<span class="sd">    :param inWaitAfterSecFloat: Количество секунд, которые ожидать после выполнения операции. По умолчанию установлено в настройках модуля Keyboard (базовое значение 0.4)</span>
<span class="sd">    :type inWaitAfterSecFloat: float, опциональный</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">l_key_item</span> <span class="ow">in</span> <span class="n">inKeyList</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">l_key_item</span> <span class="o">==</span> <span class="n">inKeyList</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]:</span>
            <span class="n">send</span><span class="p">(</span><span class="n">l_key_item</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">press</span><span class="p">(</span><span class="n">l_key_item</span><span class="p">)</span>
        <span class="n">time</span><span class="o">.</span><span class="n">sleep</span><span class="p">(</span><span class="n">inDelaySecFloat</span><span class="p">)</span>
    <span class="n">lRevKeyList</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="nb">reversed</span><span class="p">(</span><span class="n">inKeyList</span><span class="p">))</span>
    <span class="k">for</span> <span class="n">l_key_item</span> <span class="ow">in</span> <span class="n">lRevKeyList</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">l_key_item</span> <span class="o">==</span> <span class="n">lRevKeyList</span><span class="p">[</span><span class="mi">0</span><span class="p">]:</span>
            <span class="k">pass</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">release</span><span class="p">(</span><span class="n">l_key_item</span><span class="p">)</span>
        <span class="n">time</span><span class="o">.</span><span class="n">sleep</span><span class="p">(</span><span class="n">inDelaySecFloat</span><span class="p">)</span>
    <span class="n">time</span><span class="o">.</span><span class="n">sleep</span><span class="p">(</span><span class="n">inWaitAfterSecFloat</span><span class="p">)</span></div>

<div class="viewcode-block" id="HotkeyCtrlV"><a class="viewcode-back" href="../../../Robot/04_keyboard.html#pyOpenRPA.Robot.Keyboard.HotkeyCtrlV">[документация]</a><span class="k">def</span> <span class="nf">HotkeyCtrlV</span><span class="p">(</span><span class="n">inWaitAfterSecFloat</span><span class="p">:</span><span class="nb">float</span><span class="o">=</span><span class="mf">0.4</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;L+,W+: Выполнить вставку текста из буфера обмена</span>
<span class="sd">    ВНИМАНИЕ! НЕ ЗАВИСИТ ОТ ТЕКУЩЕЙ РАСКЛАДКИ КЛАВИАТУРЫ</span>
<span class="sd">    </span>
<span class="sd">    .. code-block:: python</span>

<span class="sd">        # Keyboard: Взаимодействие с клавиатурой</span>
<span class="sd">        from pyOpenRPA.Robot import Keyboard</span>
<span class="sd">        Keyboard.HotkeyCtrlV()</span>
<span class="sd">    </span>
<span class="sd">    :param inWaitAfterSecFloat: Количество секунд, которые ожидать после выполнения операции. По умолчанию установлено в настройках модуля Keyboard (базовое значение 0.4)</span>
<span class="sd">    :type inWaitAfterSecFloat: float, опциональный</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">HotkeyCombination</span><span class="p">(</span><span class="n">KEY_HOT_CTRL_LEFT</span><span class="p">,</span><span class="n">KEY_ENG_V</span><span class="p">)</span> <span class="c1"># Ctrl + v</span>
    <span class="n">time</span><span class="o">.</span><span class="n">sleep</span><span class="p">(</span><span class="n">inWaitAfterSecFloat</span><span class="p">)</span></div>

<div class="viewcode-block" id="HotkeyCtrlA_CtrlC"><a class="viewcode-back" href="../../../Robot/04_keyboard.html#pyOpenRPA.Robot.Keyboard.HotkeyCtrlA_CtrlC">[документация]</a><span class="k">def</span> <span class="nf">HotkeyCtrlA_CtrlC</span><span class="p">(</span><span class="n">inWaitAfterSecFloat</span><span class="p">:</span><span class="nb">float</span><span class="o">=</span><span class="mf">0.4</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;L+,W+: Выполнить выделение текста, после чего скопировать его в буфер обмена</span>
<span class="sd">    ВНИМАНИЕ! НЕ ЗАВИСИТ ОТ ТЕКУЩЕЙ РАСКЛАДКИ КЛАВИАТУРЫ</span>
<span class="sd">    </span>
<span class="sd">    .. code-block:: python</span>

<span class="sd">        # Keyboard: Взаимодействие с клавиатурой</span>
<span class="sd">        from pyOpenRPA.Robot import Keyboard</span>
<span class="sd">        Keyboard.HotkeyCtrlA_CtrlC() # Отправить команды: выделить все, скопировать в буфер обмена</span>
<span class="sd">    </span>
<span class="sd">    :param inWaitAfterSecFloat: Количество секунд, которые ожидать после выполнения операции. По умолчанию установлено в настройках модуля Keyboard (базовое значение 0.4)</span>
<span class="sd">    :type inWaitAfterSecFloat: float, опциональный</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">HotkeyCombination</span><span class="p">(</span><span class="n">KEY_HOT_CTRL_LEFT</span><span class="p">,</span><span class="n">KEY_ENG_A</span><span class="p">)</span> <span class="c1"># Ctrl + a</span>
    <span class="n">HotkeyCombination</span><span class="p">(</span><span class="n">KEY_HOT_CTRL_LEFT</span><span class="p">,</span><span class="n">KEY_ENG_C</span><span class="p">)</span> <span class="c1"># Ctrl + c</span>
    <span class="n">time</span><span class="o">.</span><span class="n">sleep</span><span class="p">(</span><span class="n">inWaitAfterSecFloat</span><span class="p">)</span></div>

<div class="viewcode-block" id="Send"><a class="viewcode-back" href="../../../Robot/04_keyboard.html#pyOpenRPA.Robot.Keyboard.Send">[документация]</a><span class="k">def</span> <span class="nf">Send</span><span class="p">(</span><span class="n">inKeyInt</span><span class="p">:</span><span class="nb">int</span><span class="p">,</span> <span class="n">inDoPressBool</span><span class="p">:</span><span class="nb">bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">inDoReleaseBool</span><span class="p">:</span><span class="nb">bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span><span class="n">inWaitAfterSecFloat</span><span class="p">:</span><span class="nb">float</span><span class="o">=</span><span class="n">WAIT_AFTER_SEC_FLOAT</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;L+,W+: Имитация нажатия/отпускания любой физической клавиши. Посылает событие в операционную систему, которые выполняет нажатие и отпускание данной клавиши</span>
<span class="sd">    </span>
<span class="sd">    ВНИМАНИЕ! ПРИ ПОПЫТКЕ ПЕЧАТИ ТЕКСТА БУДЕТ УЧИТЫВАТЬ ТЕКУЩУЮ РАСКЛАДКУ КЛАВИАТУРЫ. ДЛЯ ПЕЧАТИ ТЕКСТА ИСПОЛЬЗУЙ Write!</span>

<span class="sd">    .. code-block:: python</span>

<span class="sd">        # Keyboard: Взаимодействие с клавиатурой</span>
<span class="sd">        from pyOpenRPA.Robot import Keyboard</span>
<span class="sd">        Keyboard.Send(Keyboard.KEY_ENG_A) # Нажать клавишу A. Если будет активна русская раскладка, то будет выведена буква ф.</span>

<span class="sd">    :param inKeyInt: Перечень клавиш см. в разделе &quot;Коды клавиш&quot;. Пример: KEY_HOT_CTRL_LEFT,KEY_ENG_A</span>
<span class="sd">    :type inKeyInt: int</span>
<span class="sd">    :param inDoPressBool: Выполнить событие нажатия клавиши, По умолчанию True</span>
<span class="sd">    :type inDoPressBool: bool, опциональный</span>
<span class="sd">    :param inDoReleaseBool: Выполнить событие отпускания клавиши, По умолчанию True</span>
<span class="sd">    :type inDoReleaseBool: bool, опциональный</span>
<span class="sd">    :param inWaitAfterSecFloat: Количество секунд, которые ожидать после выполнения операции. По умолчанию установлено в настройках модуля Keyboard (базовое значение 0.4)</span>
<span class="sd">    :type inWaitAfterSecFloat: float, опциональный</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">send</span><span class="p">(</span><span class="n">hotkey</span><span class="o">=</span><span class="n">inKeyInt</span><span class="p">,</span> <span class="n">do_press</span><span class="o">=</span><span class="n">inDoPressBool</span><span class="p">,</span> <span class="n">do_release</span><span class="o">=</span><span class="n">inDoReleaseBool</span><span class="p">)</span>
    <span class="n">time</span><span class="o">.</span><span class="n">sleep</span><span class="p">(</span><span class="n">inWaitAfterSecFloat</span><span class="p">)</span></div>
    
<div class="viewcode-block" id="Up"><a class="viewcode-back" href="../../../Robot/04_keyboard.html#pyOpenRPA.Robot.Keyboard.Up">[документация]</a><span class="k">def</span> <span class="nf">Up</span><span class="p">(</span><span class="n">inKeyInt</span><span class="p">:</span><span class="nb">int</span><span class="p">,</span> <span class="n">inWaitAfterSecFloat</span><span class="p">:</span><span class="nb">float</span><span class="o">=</span><span class="n">WAIT_AFTER_SEC_FLOAT</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;L+,W+: Отпустить (поднять) клавишу. Если клавиша уже была поднята, то ничего не произойдет.</span>
<span class="sd">    </span>
<span class="sd">    ВНИМАНИЕ! ПРИ ПОПЫТКЕ ПЕЧАТИ ТЕКСТА БУДЕТ УЧИТЫВАТЬ ТЕКУЩУЮ РАСКЛАДКУ КЛАВИАТУРЫ. ДЛЯ ПЕЧАТИ ТЕКСТА ИСПОЛЬЗУЙ Write!</span>

<span class="sd">    ВНИМАНИЕ! ФУНКЦИЯ МОЖЕТ ОТРАБОТАТЬ НЕКОРРЕКТНО В ТОМ СЛУЧАЕ, ЕСЛИ ДЕЙСТВИЕ ПРОИСХОДИТ СРАЗУ ПОСЛЕ НАЖАТИЯ КЛАВИШИ ENTER (ИСПОЛЬЗУЙТЕ SLEEP)</span>
<span class="sd">    </span>
<span class="sd">    .. code-block:: python</span>

<span class="sd">        # Keyboard: Взаимодействие с клавиатурой</span>
<span class="sd">        from pyOpenRPA.Robot import Keyboard</span>
<span class="sd">        Keyboard.Up(Keyboard.KEY_ENG_A) # Отпустить клавишу A.</span>

<span class="sd">    :param inKeyInt: Перечень клавиш см. в разделе &quot;Коды клавиш&quot;. Пример: KEY_HOT_CTRL_LEFT, KEY_ENG_A</span>
<span class="sd">    :type inKeyInt: int</span>
<span class="sd">    :param inWaitAfterSecFloat: Количество секунд, которые ожидать после выполнения операции. По умолчанию установлено в настройках модуля Keyboard (базовое значение 0.4)</span>
<span class="sd">    :type inWaitAfterSecFloat: float, опциональный</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">send</span><span class="p">(</span><span class="n">hotkey</span><span class="o">=</span><span class="n">inKeyInt</span><span class="p">,</span> <span class="n">do_press</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">do_release</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="n">time</span><span class="o">.</span><span class="n">sleep</span><span class="p">(</span><span class="n">inWaitAfterSecFloat</span><span class="p">)</span></div>
    
<div class="viewcode-block" id="Down"><a class="viewcode-back" href="../../../Robot/04_keyboard.html#pyOpenRPA.Robot.Keyboard.Down">[документация]</a><span class="k">def</span> <span class="nf">Down</span><span class="p">(</span><span class="n">inKeyInt</span><span class="p">:</span><span class="nb">int</span><span class="p">,</span> <span class="n">inWaitAfterSecFloat</span><span class="p">:</span><span class="nb">float</span><span class="o">=</span><span class="n">WAIT_AFTER_SEC_FLOAT</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;L+,W+: Нажать (опустить) клавишу. Если клавиша уже была опущена, то ничего не произойдет.</span>
<span class="sd">    </span>
<span class="sd">    ВНИМАНИЕ! ПРИ ПОПЫТКЕ ПЕЧАТИ ТЕКСТА БУДЕТ УЧИТЫВАТЬ ТЕКУЩУЮ РАСКЛАДКУ КЛАВИАТУРЫ. ДЛЯ ПЕЧАТИ ТЕКСТА ИСПОЛЬЗУЙ Write!</span>

<span class="sd">    ВНИМАНИЕ! ФУНКЦИЯ МОЖЕТ ОТРАБОТАТЬ НЕКОРРЕКТНО В ТОМ СЛУЧАЕ, ЕСЛИ ДЕЙСТВИЕ ПРОИСХОДИТ СРАЗУ ПОСЛЕ НАЖАТИЯ КЛАВИШИ ENTER (ИСПОЛЬЗУЙТЕ SLEEP)</span>
<span class="sd">    </span>
<span class="sd">    .. code-block:: python</span>

<span class="sd">        # Keyboard: Взаимодействие с клавиатурой</span>
<span class="sd">        from pyOpenRPA.Robot import Keyboard</span>
<span class="sd">        Keyboard.Down(Keyboard.KEY_ENG_A) # Отпустить клавишу A.</span>

<span class="sd">    :param inKeyInt: Перечень клавиш см. в разделе &quot;Коды клавиш&quot;. Пример: KEY_HOT_CTRL_LEFT, KEY_ENG_A</span>
<span class="sd">    :type inKeyInt: int</span>
<span class="sd">    :param inWaitAfterSecFloat: Количество секунд, которые ожидать после выполнения операции. По умолчанию установлено в настройках модуля Keyboard (базовое значение 0.4)</span>
<span class="sd">    :type inWaitAfterSecFloat: float, опциональный</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">send</span><span class="p">(</span><span class="n">hotkey</span><span class="o">=</span><span class="n">inKeyInt</span><span class="p">,</span> <span class="n">do_press</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">do_release</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">time</span><span class="o">.</span><span class="n">sleep</span><span class="p">(</span><span class="n">inWaitAfterSecFloat</span><span class="p">)</span></div>

<div class="viewcode-block" id="IsDown"><a class="viewcode-back" href="../../../Robot/04_keyboard.html#pyOpenRPA.Robot.Keyboard.IsDown">[документация]</a><span class="k">def</span> <span class="nf">IsDown</span><span class="p">(</span><span class="n">inKeyInt</span><span class="p">:</span><span class="nb">int</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">bool</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;L+,W+: Проверить, опущена ли клавиша. Вернет True если опущена; False если поднята.</span>
<span class="sd">    </span>
<span class="sd">    ВНИМАНИЕ! ПРИ ПОПЫТКЕ ПЕЧАТИ ТЕКСТА БУДЕТ УЧИТЫВАТЬ ТЕКУЩУЮ РАСКЛАДКУ КЛАВИАТУРЫ. ДЛЯ ПЕЧАТИ ТЕКСТА ИСПОЛЬЗУЙ Write!</span>

<span class="sd">    .. code-block:: python</span>

<span class="sd">        # Keyboard: Взаимодействие с клавиатурой</span>
<span class="sd">        from pyOpenRPA.Robot import Keyboard</span>
<span class="sd">        lKeyAIsPressedBool = Keyboard.IsDown(Keyboard.KEY_ENG_A) # Проверить, опущена ли клавиша A.</span>

<span class="sd">    :param inKeyInt: Перечень клавиш см. в разделе &quot;Коды клавиш&quot;. Пример: KEY_HOT_CTRL_LEFT, KEY_ENG_A</span>
<span class="sd">    :type inKeyInt: int</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">is_pressed</span><span class="p">(</span><span class="n">inKeyInt</span><span class="p">)</span></div>

<div class="viewcode-block" id="Wait"><a class="viewcode-back" href="../../../Robot/04_keyboard.html#pyOpenRPA.Robot.Keyboard.Wait">[документация]</a><span class="k">def</span> <span class="nf">Wait</span><span class="p">(</span><span class="n">inKeyInt</span><span class="p">:</span><span class="nb">int</span><span class="p">,</span><span class="n">inWaitAfterSecFloat</span><span class="p">:</span><span class="nb">float</span><span class="o">=</span><span class="n">WAIT_AFTER_SEC_FLOAT</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;L-,W+: Блокирует осуществление программы, пока данная обозначенная клавиша не будет нажата.</span>
<span class="sd">    ВНИМАНИЕ! НЕ ЗАВИСИТ ОТ ТЕКУЩЕЙ РАСКЛАДКИ КЛАВИАТУРЫ. ОЖИДАЕТ НАЖАТИЕ СООТВЕТСВУЮЩЕЙ ФИЗИЧЕСКОЙ КЛАВИШИ</span>
<span class="sd">    </span>
<span class="sd">    .. code-block:: python</span>

<span class="sd">        # Keyboard: Взаимодействие с клавиатурой</span>
<span class="sd">        from pyOpenRPA.Robot import Keyboard</span>
<span class="sd">        Keyboard.Wait(Keyboard.KEY_ENG_A) # Ждать нажатие клавиши A.</span>

<span class="sd">    :param inKeyInt: Перечень клавиш см. в разделе &quot;Коды клавиш&quot;. Пример: KEY_HOT_CTRL_LEFT,KEY_ENG_A</span>
<span class="sd">    :type inKeyInt: int</span>
<span class="sd">    :param inWaitAfterSecFloat: Количество секунд, которые ожидать после выполнения операции. По умолчанию установлено в настройках модуля Keyboard (базовое значение 0.4)</span>
<span class="sd">    :type inWaitAfterSecFloat: float, опциональный</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">wait</span><span class="p">(</span><span class="n">hotkey</span><span class="o">=</span><span class="n">inKeyInt</span><span class="p">)</span>
    <span class="n">time</span><span class="o">.</span><span class="n">sleep</span><span class="p">(</span><span class="n">inWaitAfterSecFloat</span><span class="p">)</span></div>

<span class="k">if</span> <span class="n">CrossOS</span><span class="o">.</span><span class="n">IS_WINDOWS_BOOL</span><span class="p">:</span> <span class="n">key_to_scan_codes</span><span class="p">(</span><span class="s2">&quot;win&quot;</span><span class="p">)</span> <span class="c1"># 2022 06 10 Люблю смотреть скан код клавиши Виндовс :)</span>
</pre></div>

           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2022, ООО &#34;ОПЕН РПА&#34;.

    </p>
  </div>
    
    
    
    Собрано при помощи <a href="https://www.sphinx-doc.org/">Sphinx</a> с использованием
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">темы,</a>
    
    предоставленной <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>